/*
 * Sergey Svetlov, 2019
 * JSC "InfoTeCS", Moscow, Russia  
 */

#include "lsx.h"
#include "difference.h"
#include "generation.h"
#include "experiment.h"

#include <chrono>

Matrix<uint8_t> kuzn_matrix({0xcf, 0x6e, 0xa2, 0x76, 0x72, 0x6c, 0x48, 0x7a,
                                0xb8, 0x5d, 0x27, 0xbd, 0x10, 0xdd, 0x84, 0x94,
                                0x98, 0x20, 0xc8, 0x33, 0xf2, 0x76, 0xd5, 0xe6,
                                0x49, 0xd4, 0x9f, 0x95, 0xe9, 0x99, 0x2d, 0x20,
                                0x74, 0xc6, 0x87, 0x10, 0x6b, 0xec, 0x62, 0x4e,
                                0x87, 0xb8, 0xbe, 0x5e, 0xd0, 0x75, 0x74, 0x85,
                                0xbf, 0xda, 0x70, 0x0c, 0xca, 0x0c, 0x17, 0x1a,
                                0x14, 0x2f, 0x68, 0x30, 0xd9, 0xca, 0x96, 0x10,
                                0x93, 0x90, 0x68, 0x1c, 0x20, 0xc5, 0x06, 0xbb,
                                0xcb, 0x8d, 0x1a, 0xe9, 0xf3, 0x97, 0x5d, 0xc2,
                                0x8e, 0x48, 0x43, 0x11, 0xeb, 0xbc, 0x2d, 0x2e,
                                0x8d, 0x12, 0x7c, 0x60, 0x94, 0x44, 0x77, 0xc0,
                                0xf2, 0x89, 0x1c, 0xd6, 0x02, 0xaf, 0xc4, 0xf1,
                                0xab, 0xee, 0xad, 0xbf, 0x3d, 0x5a, 0x6f, 0x01,
                                0xf3, 0x9c, 0x2b, 0x6a, 0xa4, 0x6e, 0xe7, 0xbe,
                                0x49, 0xf6, 0xc9, 0x10, 0xaf, 0xe0, 0xde, 0xfb,
                                0x0a, 0xc1, 0xa1, 0xa6, 0x8d, 0xa3, 0xd5, 0xd4,
                                0x09, 0x08, 0x84, 0xef, 0x7b, 0x30, 0x54, 0x01,
                                0xbf, 0x64, 0x63, 0xd7, 0xd4, 0xe1, 0xeb, 0xaf,
                                0x6c, 0x54, 0x2f, 0x39, 0xff, 0xa6, 0xb4, 0xc0,
                                0xf6, 0xb8, 0x30, 0xf6, 0xc4, 0x90, 0x99, 0x37,
                                0x2a, 0x0f, 0xeb, 0xec, 0x64, 0x31, 0x8d, 0xc2,
                                0xa9, 0x2d, 0x6b, 0x49, 0x01, 0x58, 0x78, 0xb1,
                                0x01, 0xf3, 0xfe, 0x91, 0x91, 0xd3, 0xd1, 0x10,
                                0xea, 0x86, 0x9f, 0x07, 0x65, 0x0e, 0x52, 0xd4,
                                0x60, 0x98, 0xc6, 0x7f, 0x52, 0xdf, 0x44, 0x85,
                                0x8e, 0x44, 0x30, 0x14, 0xdd, 0x02, 0xf5, 0x2a,
                                0x8e, 0xc8, 0x48, 0x48, 0xf8, 0x48, 0x3c, 0x20,
                                0x4d, 0xd0, 0xe3, 0xe8, 0x4c, 0xc3, 0x16, 0x6e,
                                0x4b, 0x7f, 0xa2, 0x89, 0x0d, 0x64, 0xa5, 0x94,
                                0x6e, 0xa2, 0x76, 0x72, 0x6c, 0x48, 0x7a, 0xb8,
                                0x5d, 0x27, 0xbd, 0x10, 0xdd, 0x84, 0x94, 0x01},
                            0xc3);  //x^8+x^7+x^6+x+1

SBox<uint8_t> kuzn_sbox = {0xFC, 0xEE, 0xDD, 0x11, 0xCF, 0x6E, 0x31, 0x16, 0xFB,
    0xC4, 0xFA, 0xDA, 0x23, 0xC5, 0x04, 0x4D, 0xE9, 0x77, 0xF0, 0xDB, 0x93,
    0x2E, 0x99, 0xBA, 0x17, 0x36, 0xF1, 0xBB, 0x14, 0xCD, 0x5F, 0xC1, 0xF9,
    0x18, 0x65, 0x5A, 0xE2, 0x5C, 0xEF, 0x21, 0x81, 0x1C, 0x3C, 0x42, 0x8B,
    0x01, 0x8E, 0x4F, 0x05, 0x84, 0x02, 0xAE, 0xE3, 0x6A, 0x8F, 0xA0, 0x06,
    0x0B, 0xED, 0x98, 0x7F, 0xD4, 0xD3, 0x1F, 0xEB, 0x34, 0x2C, 0x51, 0xEA,
    0xC8, 0x48, 0xAB, 0xF2, 0x2A, 0x68, 0xA2, 0xFD, 0x3A, 0xCE, 0xCC, 0xB5,
    0x70, 0x0E, 0x56, 0x08, 0x0C, 0x76, 0x12, 0xBF, 0x72, 0x13, 0x47, 0x9C,
    0xB7, 0x5D, 0x87, 0x15, 0xA1, 0x96, 0x29, 0x10, 0x7B, 0x9A, 0xC7, 0xF3,
    0x91, 0x78, 0x6F, 0x9D, 0x9E, 0xB2, 0xB1, 0x32, 0x75, 0x19, 0x3D, 0xFF,
    0x35, 0x8A, 0x7E, 0x6D, 0x54, 0xC6, 0x80, 0xC3, 0xBD, 0x0D, 0x57, 0xDF,
    0xF5, 0x24, 0xA9, 0x3E, 0xA8, 0x43, 0xC9, 0xD7, 0x79, 0xD6, 0xF6, 0x7C,
    0x22, 0xB9, 0x03, 0xE0, 0x0F, 0xEC, 0xDE, 0x7A, 0x94, 0xB0, 0xBC, 0xDC,
    0xE8, 0x28, 0x50, 0x4E, 0x33, 0x0A, 0x4A, 0xA7, 0x97, 0x60, 0x73, 0x1E,
    0x00, 0x62, 0x44, 0x1A, 0xB8, 0x38, 0x82, 0x64, 0x9F, 0x26, 0x41, 0xAD,
    0x45, 0x46, 0x92, 0x27, 0x5E, 0x55, 0x2F, 0x8C, 0xA3, 0xA5, 0x7D, 0x69,
    0xD5, 0x95, 0x3B, 0x07, 0x58, 0xB3, 0x40, 0x86, 0xAC, 0x1D, 0xF7, 0x30,
    0x37, 0x6B, 0xE4, 0x88, 0xD9, 0xE7, 0x89, 0xE1, 0x1B, 0x83, 0x49, 0x4C,
    0x3F, 0xF8, 0xFE, 0x8D, 0x53, 0xAA, 0x90, 0xCA, 0xD8, 0x85, 0x61, 0x20,
    0x71, 0x67, 0xA4, 0x2D, 0x2B, 0x09, 0x5B, 0xCB, 0x9B, 0x25, 0xD0, 0xBE,
    0xE5, 0x6C, 0x52, 0x59, 0xA6, 0x74, 0xD2, 0xE6, 0xF4, 0xB4, 0xC0, 0xD1,
    0x66, 0xAF, 0xC2, 0x39, 0x4B, 0x63, 0xB6};

int main(int argc, char* argv[])
{
  auto start_time = std::chrono::steady_clock::now();

  const int kStateSize = 16;
  const int kRounds = 5;
    
  #ifdef WINDOWS
  srand(time(NULL));
  #endif

  ByteVector master_key(2 * kStateSize, 0);
  RandomVector(master_key);

  LSX cipher(kStateSize, kRounds, kuzn_sbox, kuzn_matrix, master_key);
  Experiment experiment(kRounds, kStateSize, cipher);
  experiment.Run();

  auto end_time = std::chrono::steady_clock::now();
  auto elapsed_s = std::chrono::duration_cast<std::chrono::seconds>(
      end_time - start_time);
  std::cout << std::dec << std::endl << "Experiment total time: "
            << elapsed_s.count() << " s" << std::endl;

  #ifdef WINDOWS
  std::cin.get();
  #endif
  return 0;
}
